﻿/***********************************************************
* 
* Mega Remote Application V 1.0
* Copyright (c) 2009 Michael Hurnaus - michbex@live.com* Feel free to use this source for whatever you want. Drop me a line if you found it useful!
* http://www.michbex.com
* 
*/

using System.Windows;
using JoystickInterface;
using System.Windows.Interop;
using RemoteEventSender;
using System;
using System.Windows.Markup;

namespace MegaRemoteApplication
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent(); 
            WindowInteropHelper windowInteropHelper = new WindowInteropHelper(this);
            DanceDanceRevolutionMatManager ddrMat = null ;
            try
            {
                ddrMat = new DanceDanceRevolutionMatManager(windowInteropHelper.Handle);
                ddrMat.KeyDown += new DanceDanceRevolutionMatManager.DdrEventHandler(ddrMat_KeyDown);
                ddrMat.KeyUp += new DanceDanceRevolutionMatManager.DdrEventHandler(ddrMat_KeyUp);
                this.Hide();

            }
            catch (XamlParseException)
            {
                MessageBox.Show("MegaRemote could not be loaded. Please verify that that DirectX is installed.", "DirectX Runtime not found.", MessageBoxButton.OK, MessageBoxImage.Error);
                this.Close();
            }
            catch (InvalidOperationException)
            {
                MessageBox.Show("No Dance Dance Revolution Mat found.", "No mat connected.", MessageBoxButton.OK, MessageBoxImage.Error);
                this.Close();
            }
        }

        void ddrMat_KeyUp(object sender, DdrEventArgs e)
        {
            //handle the key up event here if necessary
        }

        void ddrMat_KeyDown(object sender, DdrEventArgs e)
        {
            if (e.DdrId == 1)
            {
                switch (e.Key)
                {
                    case DdrKey.Start:
                        RemoteSender.Enter();
                        break;
                    case DdrKey.X:
                        RemoteSender.VolumeDown();
                        break;
                    case DdrKey.Up:
                        RemoteSender.ChannelUp();
                        break;
                    case DdrKey.Select:
                        RemoteSender.BackSpace();
                        break;
                    case DdrKey.Left:
                        RemoteSender.Left();
                        break;
                    case DdrKey.Circle:
                        RemoteSender.VolumeUp();
                        break;
                    case DdrKey.Right:
                        RemoteSender.Right();
                        break;
                    case DdrKey.Triangle:
                        RemoteSender.Mute();
                        break;
                    case DdrKey.Down:
                        RemoteSender.ChannelDown();
                        break;
                    case DdrKey.Square:
                        RemoteSender.PlayPause();
                        break;
                    default:
                        //should never get here. - ignore
                        break;
                }
            }
            else
            {
                switch (e.Key)
                {
                    case DdrKey.Start:
                        RemoteSender.Power();
                        break;
                    case DdrKey.X:
                        RemoteSender.SetChannel(1);
                        break;
                    case DdrKey.Up:
                        RemoteSender.SetChannel(2);
                        break;
                    case DdrKey.Select:
                        RemoteSender.ExitMediaCenter();
                        break;
                    case DdrKey.Left:
                        RemoteSender.SetChannel(4);
                        break;
                    case DdrKey.Circle:
                        RemoteSender.SetChannel(3);
                        break;
                    case DdrKey.Right:
                        RemoteSender.SetChannel(6);
                        break;
                    case DdrKey.Triangle:
                        RemoteSender.SetChannel(7);
                        break;
                    case DdrKey.Down:
                        RemoteSender.SetChannel(8);
                        break;
                    case DdrKey.Square:
                        RemoteSender.SetChannel(9);
                        break;
                    default:
                        //should never get here. - ignore
                        break;
                }   
            }
        }
    }
}