﻿/***********************************************************
 * 
 * Remote Sender Library V 1.0
 * Copyright (c) 2009 Michael Hurnaus - michbex@live.com
 * Feel free to use this source for whatever you want. Drop me a line if you found it useful!
 * http://www.michbex.com
 */

using System.Runtime.InteropServices;
using System.Diagnostics;
using System.IO;

namespace RemoteEventSender
{
    public class RemoteSender
    {
        public const string MEDIA_CENTER_PATH = @"C:\Windows\ehome\ehshell.exe";
        private static void SendKeyStroke(VK sendEvent)
        {
            SendKeyDown(sendEvent);
            SendKeyUp(sendEvent);
        }

        private static void SendKeyDown(VK sendEvent)
        {
            uint intReturn; // ersin was here!
            NativeMethods.INPUT structInput;
            structInput = new NativeMethods.INPUT();
            structInput.type = NativeMethods.INPUT_KEYBOARD;

            // Key down shift, ctrl, and/or alt
            structInput.ki.wScan = 0;
            structInput.ki.time = 0;
            structInput.ki.dwFlags = 0;
            structInput.ki.dwExtraInfo = NativeMethods.GetMessageExtraInfo();
            structInput.ki.wVk = (ushort)sendEvent;

            intReturn = NativeMethods.SendInput(1, ref structInput, Marshal.SizeOf(structInput));        
        }

        private static void SendKeyUp(VK sendEvent)
        {
            uint intReturn; // ersin was here!
            NativeMethods.INPUT structInput;
            structInput = new NativeMethods.INPUT();
            structInput.type = NativeMethods.INPUT_KEYBOARD;

            // Key down shift, ctrl, and/or alt
            structInput.ki.wScan = 0;
            structInput.ki.time = 0;
            structInput.ki.dwExtraInfo = NativeMethods.GetMessageExtraInfo();
            structInput.ki.wVk = (ushort)sendEvent;

            structInput.ki.dwFlags = NativeMethods.KEYEVENTF_KEYUP;
            intReturn = NativeMethods.SendInput(1, ref structInput, Marshal.SizeOf(structInput));
        }

        public static void SetChannel(int number)
        {
            switch(number){
                case 0:
                    SendKeyStroke(VK.VK_NUMPAD0);
                    break;
                case 1:
                    SendKeyStroke(VK.VK_NUMPAD1);
                    break;
                case 2:
                    SendKeyStroke(VK.VK_NUMPAD2);
                    break;
                case 3:
                    SendKeyStroke(VK.VK_NUMPAD3);
                    break;
                case 4:
                    SendKeyStroke(VK.VK_NUMPAD4);
                    break;
                case 5:
                    SendKeyStroke(VK.VK_NUMPAD5);
                    break;
                case 6:
                    SendKeyStroke(VK.VK_NUMPAD6);
                    break;
                case 7:
                    SendKeyStroke(VK.VK_NUMPAD7);
                    break;
                case 8:
                    SendKeyStroke(VK.VK_NUMPAD8);
                    break;
                case 9:
                    SendKeyStroke(VK.VK_NUMPAD9);
                    break;
                default:
                    Debugger.Break();
                    break;
            }
        }

        public static void ChannelUp()
        {
            SendKeyStroke(VK.VK_UP);
        }

        public static void ChannelDown() 
        {
            SendKeyStroke(VK.VK_DOWN);
        }

        public static void VolumeUp()
        {
            SendKeyStroke(VK.VK_VOLUME_UP);
        }

        public static void VolumeDown()
        {
            SendKeyStroke(VK.VK_VOLUME_DOWN);
        }

        public static void Mute()
        {
            SendKeyStroke(VK.VK_VOLUME_MUTE);
        }

        public static void Power()
        {
            //SendKeyStroke(VK.VK_LAUNCH_APP2); //HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\explorer\AppKey\18 was 
            //start media center:
            if (File.Exists(MEDIA_CENTER_PATH))
            {
                System.Diagnostics.Process.Start(MEDIA_CENTER_PATH);
            }
            //else fail silently -> don't do anything
        }

        public static void PlayPause()
        {
            SendKeyStroke(VK.VK_MEDIA_PLAY_PAUSE);
        }

        public static void Left()
        {
            SendKeyStroke(VK.VK_LEFT);
        }

        public static void Right()
        {
            SendKeyStroke(VK.VK_RIGHT);
        }

        public static void ExitMediaCenter()
        {
            SendKeyDown(VK.VK_MENU);
            SendKeyStroke(VK.VK_F4);
            SendKeyUp(VK.VK_MENU);
        }

        public static void Enter()
        {
            SendKeyStroke(VK.VK_RETURN);
        }

        public static void BackSpace()
        {
            SendKeyStroke(VK.VK_BACK);
        }
    } 
}
